package com.cpop.api.cloudDb.handler;

import com.alibaba.fastjson.JSONObject;
import com.cpop.api.cloudDb.core.constant.CloudDbUrl;
import com.cpop.api.cloudDb.core.dto.CloudCustomerDto;
import com.cpop.api.cloudDb.core.dto.CloudStudentDto;
import com.cpop.common.utils.StringUtils;
import com.cpop.core.base.exception.UtilException;
import com.mybatisflex.core.paginate.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.List;

/**
 * 云客户学员工具类
 * @author DB
 * @version 1.0.0
 * @since 2024-01-09 14:30
 */
@Component
@Slf4j
public class CloudCustomerStudentHandler {

    @Autowired
    private RestTemplate restTemplate;

    /**
     * 获取客户分页
     * @author DB
     * @since 2024/1/9
     * @param pageNum 分页参数
     * @param pageSize 分页参数
     * @param startDate 开始日期
     * @param endDate 结束日期
     * @param storeId 云校区id
     * @param customerId 云客户id
     * @return Page<CloudCustomerDto>
     */
    public Page<CloudCustomerDto> getCustomerPage(Integer pageNum, Integer pageSize, String startDate, String endDate, String storeId,String customerId) {
        JSONObject jsonBody = new JSONObject();
        jsonBody.put("_type", "customer");
        //分页参数
        jsonBody.put("page", pageNum);
        jsonBody.put("limit", pageSize);
        //开始日期结束日期
        if (StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate)) {
            jsonBody.put("startTime", startDate);
            jsonBody.put("endTime", endDate);
        }
        if (StringUtils.isNotBlank(customerId)){
            jsonBody.put("customerId", customerId);
        }
        //校区id
        jsonBody.put("storeId", storeId);
        JSONObject jsonObject = restTemplate.postForObject(CloudDbUrl.DATA_CLOUD, jsonBody, JSONObject.class);
        Page<CloudCustomerDto> page = Page.of(pageNum, pageSize);
        if (jsonObject != null) {
            if (jsonObject.getBoolean("success")) {
                List<CloudCustomerDto> customerDtoList = jsonObject.getJSONArray("list").toJavaList(CloudCustomerDto.class);
                page.setRecords(customerDtoList);
                page.setTotalPage(jsonObject.getInteger("total"));
                page.setTotalRow(jsonObject.getInteger("total"));
                return page;
            } else {
                throw new UtilException(jsonObject.getString("error"));
            }
        } else {
            return page;
        }
    }

    /**
     * 获取学员分页
     * @author DB
     * @since 2024/1/9
     * @param pageNum 分页参数
     * @param pageSize 分页参数
     * @param startDate 开始日期
     * @param endDate 结束日期
     * @param storeId 云校区id
     * @param customerId 云客户id
     * @param studentId 云学员id
     * @return Page<CloudStudentDto>
     */
    public Page<CloudStudentDto> getStudentPage(Integer pageNum, Integer pageSize, String startDate, String endDate, String storeId, String customerId, String studentId) {
        JSONObject jsonBody = new JSONObject();
        jsonBody.put("_type", "student");
        //分页参数
        jsonBody.put("page", pageNum);
        jsonBody.put("limit", pageSize);
        //开始日期结束日期
        if (StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate)) {
            jsonBody.put("startTime", startDate);
            jsonBody.put("endTime", endDate);
        }
        if (StringUtils.isNotBlank(customerId)) {
            jsonBody.put("customerId", customerId);
        }
        if (StringUtils.isNotBlank(studentId)) {
            jsonBody.put("studentId", studentId);
        }
        //校区id
        jsonBody.put("storeId", storeId);
        JSONObject jsonObject = restTemplate.postForObject(CloudDbUrl.DATA_CLOUD, jsonBody, JSONObject.class);
        Page<CloudStudentDto> page = Page.of(pageNum, pageSize);
        if (jsonObject != null) {
            if (jsonObject.getBoolean("success")) {
                List<CloudStudentDto> studentDtoList = jsonObject.getJSONArray("list").toJavaList(CloudStudentDto.class);
                page.setRecords(studentDtoList);
                page.setTotalPage(jsonObject.getInteger("total"));
                page.setTotalRow(jsonObject.getInteger("total"));
                return page;
            } else {
                throw new UtilException(jsonObject.getString("error"));
            }
        } else {
            return page;
        }
    }

}
